#ifndef __AUC_DEFS__
#define __AUC_DEFS__

#include <float.h>
#include <math.h>


/* useful macros */
#define FALSE 0
#define TRUE 1

#define MAX(x, y)  ((x) >= (y) ? (x) : (y))
#define MIN(x, y)  ((x) < (y) ? (x) : (y))


/* define types for easy adaptation */
#define LONG_INT_TYPE unsigned long long int

/* use long double */
#define FLT_TYPE long double
#define FLT_TYPE_MAX LDBL_MAX
#define FLT_TYPE_MIN LDBL_MIN
#define FMT "%Lf"
#define PFMT "%20.20Lf"
#define PI 3.1415926535897932384626433832795029L  /* pi */
#define PI_2 1.5707963267948966192313216916397514L  /* pi/2 */
#define _2_PI 0.6366197723675813430755350534900574L  /* 2/pi */
#define SQRT_2 1.4142135623730950488016887242096981L  /* sqrt(2) */
#define ABS_F(x) fabsl((x))
#define SQRT_F(x) sqrtl((x))
#define HYPOT_F(x, y) hypotl((x), (y))
#define SIN_F(x) sinl((x))
#define COS_F(x) cosl((x))
#define EXP_F(x) expl((x))

/* use double */
//#define FLT_TYPE double
//#define FLT_TYPE_MAX DBL_MAX
//#define FLT_TYPE_MIN DBL_MIN
//#define FMT "%lf"
//#define PFMT "%15.15lf"
//#define PI M_PI
//#define PI_2 M_PI_2
//#define _2_PI M_2_PI
//#define SQRT_2 M_SQRT2
//#define ABS_F(x) fabs((x))
//#define SQRT_F(x) sqrt((x))
//#define HYPOT_F(x, y) hypot((x), (y))
//#define SIN_F(x) sin((x))
//#define COS_F(x) cos((x))
//#define EXP_F(x) exp((x))

#endif /* __AUC_DEFS__ */
