#ifndef __DATA_ACCESS__
#define __DATA_ACCESS__


#include <stdio.h>
#include <stdlib.h>

#include "auc_defs.h"

/* buffer size for reading lines */
#define MAXLINE 10000UL


/* Count number of attributes.
 *
 * Class attribute is included. */
size_t
get_nattrs(FILE * f);

/* read next record and put it in X.  return the class or -1 if end of
 * file.  class 2 means missing class value */
int
read_record(FILE * f, FLT_TYPE * X, size_t nattrs);


/* caching the data file in memory */
void
cache_file(FILE * f, size_t nattrs);
void
free_default_cache(void);

#endif  /* __DATA_ACCESS__ */
