#ifndef __OPT_PARSE__
#define __OPT_PARSE__


#include <stdlib.h>
#include <stdio.h>

#include "auc_defs.h"
#include "attribute_norms.h"


struct options
{
    char * train_fname;		/* training file name */
    char * test_fname;		/* test file name */
    size_t maxdeg;		/* maximum polynomial degree */
    size_t maxiter;		/* maximum number of iterations */
    enum norm_type norm;	/* norm to use for attribute
				   normalization */
    int print_weights;		/* whether to print the resulting
				   weights */
    FLT_TYPE lin_opt_step;	/* step to use in linear optimisation */
    int cache_data;		/* shold we cache dataset in memory? */
    int exact;			/* compute AUC exactly */
    int soft_auc;		/* should we compute soft-AUC instead
				   of standard AUC */
    FLT_TYPE beta;		/* value of beta for soft-AUC */

    int regul;			/* use regularization? */
    int rumelhart;	      	/* use Rumelhart regularization? */
    int laplace;	      	/* use laplace regularization? */
    FLT_TYPE lambda;		/* regularization parameter */
};

void
parse_options(struct options * opt, int argc, char * argv[]);

#endif
