#include <math.h>
#include <float.h>

#include "scaling.h"

#define FALSE 0
#define TRUE 1



void
init_minmax(struct minmax * mm)
{
    mm -> seen_class0 = FALSE;
    mm -> min_class0 = FLT_TYPE_MAX;
    mm -> max_class0 = FLT_TYPE_MIN;

    mm -> seen_class1 = FALSE;
    mm -> min_class1 = FLT_TYPE_MAX;
    mm -> max_class1 = FLT_TYPE_MIN;

    mm -> max_M = (FLT_TYPE)-1;
    mm -> scale_factor = (FLT_TYPE)1;
    mm -> rescale_factor = (FLT_TYPE)1;
}


int
update_minmax(struct minmax * mm, FLT_TYPE f, int class)
{
    int do_rescale;
    FLT_TYPE M = (FLT_TYPE)0;

    /* update the minimum and maximum of f */
    if(class == 0)
    {
	mm -> seen_class0 = TRUE;
	if(f < mm -> min_class0)
	{
	    mm -> min_class0 = f;
	}
	if(f > mm -> max_class0)
	{
	    mm -> max_class0 = f;
	}
    }
    else
    {
	mm -> seen_class1 = TRUE;
	if(f < mm -> min_class1)
	{
	    mm -> min_class1 = f;
	}
	if(f > mm -> max_class1)
	{
	    mm -> max_class1 = f;
	}
    }

    /* compute the max of absolute value and difference */
    if(mm -> seen_class0)
    {
	M = MAX(ABS_F(mm -> max_class0), ABS_F(mm -> min_class0));
    }
    if(mm -> seen_class1)
    {
	M = MAX(M, MAX(ABS_F(mm -> max_class1),
		       ABS_F(mm -> min_class1)));
    }
    if(mm -> seen_class0 && mm -> seen_class1)
    {
	M = MAX(M, MAX(ABS_F(mm -> max_class1 - mm -> min_class0),
		       ABS_F(mm -> min_class1 - mm -> max_class0)));
    }

    mm -> rescale_factor = (FLT_TYPE)1;
    do_rescale = FALSE;
    if(M > mm -> max_M)
    {
        mm -> scale_factor = (FLT_TYPE)1 / M;
        if(mm -> max_M >= (FLT_TYPE)0)
        {
	    mm -> rescale_factor *= mm -> max_M / M;
	    do_rescale = TRUE;
        }
        mm -> max_M = M;
    }

    return do_rescale;
}
