#ifndef __SCALING__
#define __SCALING__


/* struct which keeps apropriate min and max values and computes current
   maximum absolute value and difference for scaling. */


#include "auc_defs.h"


struct minmax
{
    int seen_class0;		/* have we seen class 0 yet? */
    int seen_class1;		/* have we seen class 1 yet? */

    FLT_TYPE min_class0;
    FLT_TYPE max_class0;
    FLT_TYPE min_class1;
    FLT_TYPE max_class1;

    FLT_TYPE max_M;		/* currently largest value to be kept
				   in [-1,1] */
    FLT_TYPE scale_factor;	/* scale f by this factor */
    FLT_TYPE rescale_factor;	/* how much to rescale supports during
				   current iteration to account for
				   increase in max_M */
};


/* initialize the minmax struct */
void
init_minmax(struct minmax * mm);

/* updates the mm struct for given value of f and given class.

Return a logical value of whether a rescale is needed in this
iteration. */
int
update_minmax(struct minmax * mm, FLT_TYPE f, int class);


#endif  /* __SCALING__ */
