#ifndef __VECT_UTILS__
#define __VECT_UTILS__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "auc_defs.h"


/* print a vector of floats */
void
vect_print(const FLT_TYPE * V, size_t n);


/* check orthogonality of two vectors */
FLT_TYPE
vect_check_orthogonality(const FLT_TYPE * weights, const FLT_TYPE * grad,
			 size_t nattrs);

/* normalize vector src and put the result in dst.  src and dst may be
   the same.  Returns the norm of the vector before normalization. */
FLT_TYPE
vect_normalize(const FLT_TYPE * src, FLT_TYPE * dst, size_t size);


/* project a vector onto a space orthogonal to another vector.
   
   src and projection may overlap.
 */
void
vect_project_on_orthogonal_space(const FLT_TYPE * src,
				 const FLT_TYPE * norm_vect,
				 FLT_TYPE * projection,
				 size_t size);


/* compute the value of optimized function.

   Should it be moved elsewhere ? */
FLT_TYPE
compute_f(const FLT_TYPE * weights, const FLT_TYPE * X, size_t nattrs);



#endif  /* __VECT_UTILS__ */
